﻿--
-- Heinzelmännchen
-- 

Heinzel = {};
Heinzel.Tage = {};

Heinzel.saveconfigbool = true;  -- set this to "false" if you don't like to have a saved config-file and enter your Day-preferences in the field below

Heinzel.Tage[g_i18n:getText("financesDay1")] =   0; -- Montag / Monday
Heinzel.Tage[g_i18n:getText("financesDay2")] =   0; -- Dienstag / Tuesday
Heinzel.Tage[g_i18n:getText("financesDay3")] =   0; -- Mittwoch / Wednesday
Heinzel.Tage[g_i18n:getText("financesDay4")] = 100; -- Donnerstag / Thursday
Heinzel.Tage[g_i18n:getText("financesDay5")] =   0; -- Freitag / Friday
Heinzel.Tage[g_i18n:getText("financesDay6")] =   0; -- Samstag / Saturday
Heinzel.Tage[g_i18n:getText("financesDay7")] = 100; -- Sontag / Sunday
	

addModEventListener(Heinzel);
Heinzel.nextDay = 0;
Heinzel.count = 0;
Heinzel.config = getUserProfileAppPath().."/Heinzelmaennchen_cfg.xml";

function Heinzel:loadMap(name)
	Heinzel:loadConfig();
	--print(ScriptPack.DebugExtension:tableToString(Heinzel.Tage));
end;

function Heinzel:deleteMap()
	if self.saveconfigbool then
		Heinzel:saveConfig()
	end;
end

function Heinzel:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Heinzel:keyEvent(unicode, sym, modifier, isDown)
end;

function Heinzel:update(dt)
	if g_currentMission.environment.currentDay >= self.nextDay then
		if self.count < 0 then -- neuer Tag und kein Plan => Plan machen
			local Wochentag = g_i18n:getText("financesDay"..(((g_currentMission.environment.currentDay+6) % 7)+1))
			--print("Wochentag: "..Wochentag);
			self.count = math.floor(table.getn(g_currentMission.vehicles) * self.Tage[Wochentag] / 100 + 0.5);
			if self.Tage[Wochentag] > 0 and self.count <= 0 then
				self.count = 1;
			end;
			--print(table.getn(g_currentMission.vehicles).." Fahrzeuge ("..self.count.." putzen)");
		elseif self.count > 0 then -- wenn noch Arbeit zu tun ist
			local Fahrzeug = nil;
			local dreck = -1;
			for k , Fz in pairs(g_currentMission.vehicles) do
				if Fz.getDirtAmount ~= nil then
					if Fz:getDirtAmount() > dreck then
						Fahrzeug = Fz;
						dreck = Fz:getDirtAmount();
					end;
				end;
			end;
			if Fahrzeug ~= nil then
				--print(Fahrzeug.name.." "..Fahrzeug:getDirtAmount().." Dreck geputzt!");
				Fahrzeug:setDirtAmount(0);
				self.count = self.count - 1;
			end;
		else -- Arbeit erlegigt 
			self.count = -1;
			self.nextDay = g_currentMission.environment.currentDay + 1;
		end;
	end;
end;

function Heinzel:draw()   
end;

-------------------------------------------------------------
--	Load / Save Config
-------------------------------------------------------------
function Heinzel:loadConfig()
	local XMLfile;
	if fileExists(self.config) then -- load config
		XMLfile = loadXMLFile("Heinzel_XML", self.config, "options");
	end;
	if XMLfile ~= nil then
		for Wochentag = 1,7,1 do
			self.Tage[g_i18n:getText("financesDay"..Wochentag)] = getXMLInt(XMLfile, "options."..g_i18n:getText("financesDay"..Wochentag));
		end;
	end;
	
end;

function Heinzel:saveConfig()
	local XMLfile;
	if not fileExists(self.config) then
		XMLfile = createXMLFile("Heinzel_XML", self.config, "options");
	else
		XMLfile = loadXMLFile("Heinzel_XML", self.config, "options");
	end;
	if XMLfile ~= nil then
		for Wochentag = 1,7,1 do
			setXMLInt(XMLfile, "options."..g_i18n:getText("financesDay"..Wochentag), self.Tage[g_i18n:getText("financesDay"..Wochentag)]);
		end;
		saveXMLFile(XMLfile);
	end;
	
end;

local modItem = ModsUtil.findModItemByModName(g_currentModName);
print(string.format("--- loading %s mod V%.2f (by %s) ---", modItem.title, modItem.version, modItem.author));